/*
 *  AME_MPIO.cpp
 *  Acxxx
 *
 *  Copyright (c) 2004-2014 Accusys, Inc. All rights reserved.
 *
 */


#include "AME_module.h"
#include "AME_import.h"
#include "MPIO.h"
#include "ACS_MSG.h"

#if defined (AME_MAC)
    #include "Acxxx.h"
#endif

AME_U32		MPIO_HBA_Count=0;
AME_U32		MPIO_Inited=0;
MPIO_Global MPIOGlobal;


AME_U32 MPIO_Init_Prepare(pMPIO_DATA pMPIODATA,pAME_Data pAMEData,pAME_Module_Prepare pAMEModulePrepare)
{
	return  AME_Init_Prepare(pAMEData,pAMEModulePrepare);
}


AME_U32 MPIO_GetPAGE0_Data_Add(pMPIO_DATA pMPIODATA,pMPIO_Get_PAGE_0_Data pMPIO_Get_PAGE0_Data ,AME_U32 Raid_ID)
{
	AME_U32		i;

	if (pMPIODATA->MPIO_RAIDDATA[Raid_ID].GetPAGE0_Data.Ready != TRUE) {
		pMPIODATA->MPIO_RAIDDATA[Raid_ID].GetPAGE0_Data.Ready = TRUE;
	    AME_Memory_copy((PVOID)(pMPIODATA->MPIO_RAIDDATA[Raid_ID].GetPAGE0_Data.Production_ID),(PVOID)(pMPIO_Get_PAGE0_Data->Production_ID), 0x10);
		AME_Memory_copy((PVOID)(pMPIODATA->MPIO_RAIDDATA[Raid_ID].GetPAGE0_Data.Model_Name),(PVOID)(pMPIO_Get_PAGE0_Data->Model_Name), 0x10);
		AME_Memory_copy((PVOID)(pMPIODATA->MPIO_RAIDDATA[Raid_ID].GetPAGE0_Data.Serial_Number),(PVOID)(pMPIO_Get_PAGE0_Data->Serial_Number), 0x10);

		MPIO_Msg("(%d)New T-Pairing Raid :%d\n",pMPIODATA->MPIO_Serial_Number,Raid_ID);

		return TRUE;
	} else {

		MPIO_Msg_Err("(%d)New T-Pairing Raid :%d, Had exist???\n",pMPIODATA->MPIO_Serial_Number,Raid_ID);
	}

	return FALSE;
}

AME_U32 MPIO_Path_Add(pMPIO_DATA pMPIODATA_host,pMPIO_DATA pMPIODATA_path,AME_U32 host_RaidID ,AME_U32 path_RaidID)
{
	AME_U32	PATH_ID;

	if (pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount > MPIO_MAX_support_HBA) {
		MPIO_Msg_Err("T-Pairing_Path_Add Fail. Host/Path/Host RAID_ID/Path RAID_ID:%d/%d/%d/%d.\n",pMPIODATA_host->MPIO_Serial_Number,pMPIODATA_path->MPIO_Serial_Number,host_RaidID,path_RaidID);
		MPIO_Msg_Err("T-Pairing_Path_Add Fail: Host:%d, RAID:%d add to MPIO Host:%d, RAID:%d. Path count > supported:%d\n",pMPIODATA_path->MPIO_Serial_Number,path_RaidID,pMPIODATA_host->MPIO_Serial_Number,host_RaidID,MPIO_MAX_support_HBA);
		return FALSE;
	}

	PATH_ID = pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount;
	
	pMPIODATA_path->RAIDDATA[path_RaidID].Path_State = MPIO_Path_Built;
	pMPIODATA_path->RAIDDATA[path_RaidID].pMPIOData_host= pMPIODATA_host;
	pMPIODATA_path->RAIDDATA[path_RaidID].host_RaidID = host_RaidID;
	pMPIODATA_path->RAIDDATA[path_RaidID].Path_Number = PATH_ID;
	
	pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[PATH_ID].Path_ID_of_Host_RAID = PATH_ID;
	pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[PATH_ID].pMPIOData = pMPIODATA_path;
	pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[PATH_ID].AME_RAID_ID = path_RaidID;
	pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount++;
	MPIO_Msg("T-Pairing_Path_Add : Host:%d, RAID:%d add to T-Pairing Host:%d, RAID:%d. Path count=%d\n",pMPIODATA_path->MPIO_Serial_Number,path_RaidID,pMPIODATA_host->MPIO_Serial_Number,host_RaidID,pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount);

    if(pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount == MAX_TBS_Device) {
        MPIO_Msg("T-Pairing Enable.\n");
    }

	return TRUE;

}


// host_data_keep : TRUE, for resume, path will be remove first, and then when AME ready, can add to same host.
AME_U32 MPIO_Path_Remove(pMPIO_DATA pMPIODATA_host,pMPIO_DATA pMPIODATA_path,AME_U32 host_RaidID ,AME_U32 path_RaidID, AME_U32 host_data_keep)
{
	AME_U32	i,j,PATHCount;
	pMPIO_DATA pMPIODATA_temp;

	//if (MPIOGlobal.pMPIOData[0] == NULL) {
	//    MPIO_Msg("T-Pairing_Path_Remove:  T-Pairing_Path_Remove: Master path remove.\n");
	//    return FALSE;
	//}
	
	pMPIODATA_path->RAIDDATA[path_RaidID].Path_State |= MPIO_Path_Disabled;
	pMPIODATA_path->RAIDDATA[path_RaidID].pMPIOData_host = NULL;
	pMPIODATA_path->RAIDDATA[path_RaidID].host_RaidID = host_RaidID;

	PATHCount = pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount;
	for (i=0;i<PATHCount;i++) {
		if (pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[i].pMPIOData == pMPIODATA_path) {
			pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount--;
			
			if (pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount == 0) {
				if (host_data_keep == FALSE) {
					pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].GetPAGE0_Data.Ready = FALSE;
				}
			}
			
			for (j=(i+1);j<PATHCount;j++) {
				pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[j-1].Path_ID_of_Host_RAID = j-1;
				pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[j-1].pMPIOData = pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[j].pMPIOData;
				pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[j-1].AME_RAID_ID = pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[j].AME_RAID_ID;
			}
			MPIO_Msg("T-Pairing_Path_Remove : Host:%d, RAID:%d remove from T-Pairing Host:%d, RAID:%d. Path count=%d\n",pMPIODATA_path->MPIO_Serial_Number,path_RaidID,pMPIODATA_host->MPIO_Serial_Number,host_RaidID,pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount);
			
			//AME_Msg("(%d)MPIO_Path_Remove : Raid(%d) pMPIOData_host(%p) pMPIODATA(%p)\n",pMPIODATA_path->MPIO_Serial_Number,host_RaidID,pMPIODATA_host,pMPIODATA_path);
    		if (pMPIODATA_host == pMPIODATA_path) {
    		    PATHCount = pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount;
    		    //AME_Msg("(%d)MPIO_Path_Remove : PATHCount(%d)\n",pMPIODATA_path->MPIO_Serial_Number,PATHCount);
    		    if (PATHCount>0) {
    		        pMPIODATA_temp = pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].Path_RAIDData[PATHCount].pMPIOData;
    		        if (pMPIODATA_temp != NULL) {
    		            MPIO_Msg("(%d)T-Pairing_Path_Remove : Call slave path(%d) add lun\n",pMPIODATA_path->MPIO_Serial_Number,pMPIODATA_temp->MPIO_Serial_Number);
    		            MPIO_Data_Init(pMPIODATA_temp,FALSE);
    		            ((pAME_Data)pMPIODATA_temp->pAMEData)->AME_NTHost_data.Hotplug_State = NT_Hotplug_First_Load_Wait_SW_Ready;
    		        }
    		    }
    		}
			
			return TRUE;
		}
	}
	
	MPIO_Msg_Err("T-Pairing_Path_Remove Fail. : Host/Path:%d/%d, path count=%d\n",pMPIODATA_host->MPIO_Serial_Number,pMPIODATA_path->MPIO_Serial_Number,pMPIODATA_host->MPIO_RAIDDATA[host_RaidID].PATHCount);
	return FALSE;	

}

AME_U32 MPIO_Get_Path_count(pMPIO_DATA pMPIODATA, AME_U32 RaidID)
{
    AME_U32 PATHCount=0,Host_RaidID=0;
    pMPIO_DATA pMPIODATA_Host;
    
    pMPIODATA_Host = pMPIODATA->RAIDDATA[RaidID].pMPIOData_host;
    Host_RaidID = pMPIODATA->RAIDDATA[RaidID].host_RaidID;
    PATHCount = pMPIODATA_Host->MPIO_RAIDDATA[Host_RaidID].PATHCount;
    
    return PATHCount;
}


AME_U32 MPIO_Data_Init(pMPIO_DATA pMPIODATA, AME_U32 page_data_keep)
{
	AME_U32				i,j;
	pMPIO_RAID_DATA		pMPIO_RAIDDATA;

	for (i=0;i<MAX_RAID_System_ID;i++) {
		pMPIODATA->RAIDDATA[i].pMPIOData_original = pMPIODATA;
		pMPIODATA->RAIDDATA[i].pMPIOData_host = NULL;
		pMPIODATA->RAIDDATA[i].Path_State = MPIO_Path_stand_alone;
	}
	
	for (i=0;i<MAX_RAID_System_ID;i++) {
		pMPIO_RAIDDATA = &pMPIODATA->MPIO_RAIDDATA[i];
		pMPIO_RAIDDATA->TotalIssue_CMDCount = 0;
		pMPIO_RAIDDATA->PATHCount = 0;

		if (page_data_keep != TRUE) {
			pMPIO_RAIDDATA->GetPAGE0_Data.Ready = FALSE;
	    }
		
		for (j=0;j<MPIO_MAX_support_HBA;j++) {
			pMPIO_RAIDDATA->Path_RAIDData[j].pMPIOData = NULL;
		}
	}

	return TRUE;
}


AME_U32 MPIO_Init_Setup(pMPIO_DATA pMPIODATA)
{
	AME_U32  i,j;
	
	for (i=0;i<MPIO_MAX_support_HBA;i++) {
	    if (MPIOGlobal.pMPIOData[i] == pMPIODATA) {
	        MPIO_Msg("MPIO_Init_Setup : Host:%d find the same MPIODATA in MPIOGlobal[%d].\n",pMPIODATA->MPIO_Serial_Number,i);
	        return TRUE;
	    }
	}
	
	for (i=0;i<MPIO_MAX_support_HBA;i++) {
	    if (MPIOGlobal.pMPIOData[i] == NULL) {
	        
	        // Clear MPIO Global data
	        
	        if ((MPIO_Inited != TRUE) && (i == 0)) {
	            MPIO_Inited = TRUE;
			    for (j=0;j<MPIO_MAX_support_HBA;j++) {
			        MPIOGlobal.pMPIOData[j] = NULL;
			    }
			    MPIO_Msg("MPIO_Init_Setup : Clear all MPIODATA to NULL.\n",pMPIODATA->MPIO_Serial_Number,i);
	        }
	        
	        pMPIODATA->MPIO_Serial_Number = i;
	        MPIOGlobal.pMPIOData[i] = pMPIODATA;
	        MPIO_Msg("MPIO_Init_Setup : Host:%d add MPIOData in MPIOGlobal[%d].\n",pMPIODATA->MPIO_Serial_Number,i);
	        break;
	    }
	}
    
	MPIO_HBA_Count++;

	return TRUE;
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_ReInit(pMPIO_DATA pMPIODATA,pAME_Data pAMEData,pAME_Module_Init_Prepare pAMEModule_Init_Prepare)
{
	MPIO_Msg("T-Pairing_ReInit : Host: [%d], Total Host: [%d]\n", pMPIODATA->MPIO_Serial_Number,MPIO_HBA_Count);
	
	if (FALSE == MPIO_Support_Check(pMPIODATA)) {
		return AME_ReInit(pAMEData,pAMEModule_Init_Prepare);
    }
	
	MPIO_Data_Init(pMPIODATA, TRUE);

	return AME_ReInit(pAMEData,pAMEModule_Init_Prepare);
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Init(pMPIO_DATA pMPIODATA,pAME_Data pAMEData,pAME_Module_Init_Prepare pAMEModule_Init_Prepare)
{
	AME_U32 	i;

	pMPIODATA->pAMEData = (PVOID)pAMEData;
	pAMEData->pMPIOData = (PVOID)pMPIODATA;
	pMPIODATA->Vendor_ID = pAMEModule_Init_Prepare->Vendor_ID;
	pMPIODATA->Device_ID = pAMEModule_Init_Prepare->Device_ID;
	
    //#ifdef Enable_MPIO_message
	//    ACS_message((pMSG_DATA)(pMPIODATA->pMSGDATA),MPIO_init,MPIO_Init_start,NULL);
    //#endif
	
	// Only support 4 HBA
	if (MPIO_HBA_Count > MPIO_MAX_support_HBA) {
		AME_Msg_Err("(%d)Host_Init fail: Host_Count:%d >= supported Host:%d\n", pMPIODATA->MPIO_Serial_Number,MPIO_HBA_Count,MPIO_MAX_support_HBA);
		return FALSE;
	}

	AME_Msg("Host_Init :(%d), Total Host: [%d] ...\n", pMPIODATA->MPIO_Serial_Number,MPIO_HBA_Count);
	
	#if defined (AME_MAC)
	    // Card_ID is Mac driver variable only, support print message.
	    Card_ID = pMPIODATA->MPIO_Serial_Number;
	#endif
		
	MPIO_Data_Init(pMPIODATA,FALSE);

	pAMEData->AME_Serial_Number = pMPIODATA->MPIO_Serial_Number;

    //#ifdef Enable_MPIO_message
	//    ACS_message((pMSG_DATA)(pMPIODATA->pMSGDATA),MPIO_init,MPIO_Init_Done_Success,NULL);
    //#endif
	
	if (FALSE == AME_Init(pAMEData,pAMEModule_Init_Prepare)){ 
    	return FALSE; 	    
	}
	
	return TRUE;
   
}


AME_U32 
MPIO_Single_NT_Check(pAME_Data pAMEData)
{
    AME_U32 i;
    
    for (i=0;i<MPIO_MAX_support_HBA;i++) {
		
		if (MPIOGlobal.pMPIOData[i] == NULL) {
		    continue;
		}
		
		if ((MPIOGlobal.pMPIOData[i]->Device_ID == AME_8508_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_8608_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_87B0_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_87B0_DID1_NT) ) {
		    
		    if (pAMEData->pMPIOData == (PVOID)MPIOGlobal.pMPIOData[i]) {
		        return TRUE;
		    }
		    
		    return FALSE;
		}
		
	}
    
    return FALSE;
}


AME_U32 
MPIO_Support_NT_Check(pAME_Data pAMEData)
{
    AME_U32 i, count = 0;
    
    for (i=0;i<MPIO_MAX_support_HBA;i++) {
		if (MPIOGlobal.pMPIOData[i] == NULL) {
		    continue;
		}
		
		if ((MPIOGlobal.pMPIOData[i]->Device_ID == AME_8508_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_8608_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_87B0_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_87B0_DID1_NT)) {
		    count++;
		}
	}
	
	if (count > MAX_NT_Device) {
	    return FALSE;    
	}
    
    return TRUE;
}


AME_U32 
MPIO_TBS_NT_Check(pAME_Data pAMEData)
{
    AME_U32 i, count = 0;
    
    for (i=0;i<MPIO_MAX_support_HBA;i++) {
		if (MPIOGlobal.pMPIOData[i] == NULL) {
		    continue;
		}
		
		if ((MPIOGlobal.pMPIOData[i]->Device_ID == AME_8608_DID1_TBS) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_8608_DID2_TBS) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_87B1_DID_TBS) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_8733_DID_TBS)) {
		    count++;
		}
	}
	
	if (count > MAX_TBS_Device) {
	    return FALSE;    
	}
    
    return TRUE;
}


AME_U32 
MPIO_Eeprom_Need_Update_Check(pAME_Data pAMEData)
{
    AME_U32 i;
    
    if (TRUE == AME_Check_is_TBS_Device(pAMEData)) {
       return TRUE;
    }
    
    for (i=0;i<MPIO_MAX_support_HBA;i++) {		
		if (MPIOGlobal.pMPIOData[i] != NULL) {
			if ( (pAMEData->AME_LED_data.LED_HBA_Bus_Number == ((pAME_Data)(MPIOGlobal.pMPIOData[i]->pAMEData))->AME_LED_data.LED_HBA_Bus_Number) &&
			     (((pAME_Data)(MPIOGlobal.pMPIOData[i]->pAMEData))->Update_Eeprom == TRUE)  ) {
		        return FALSE;
		    }
		}
		
	}
    
    return TRUE;
}


AME_U32 
MPIO_Switch_SN_Check(pAME_Data pAMEData,AME_U32 SW_SN)
{
    AME_U32 i;
    
    for (i=0;i<MPIO_MAX_support_HBA;i++) {
		
		if (MPIOGlobal.pMPIOData[i] == NULL) {
		    continue;
		}
		
		if ((MPIOGlobal.pMPIOData[i]->Device_ID == AME_8508_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_8608_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_87B0_DID_NT) ||
		    (MPIOGlobal.pMPIOData[i]->Device_ID == AME_87B0_DID1_NT) ) {
    		if(pAMEData != MPIOGlobal.pMPIOData[i]->pAMEData) {
        		if (SW_SN == ((pAME_Data)(MPIOGlobal.pMPIOData[i]->pAMEData))->AME_NTHost_data.NT_SW_SN) {
        		    return FALSE;
        		}		
        	}				    
		}
	}
	
    pAMEData->AME_NTHost_data.NT_SW_SN  = SW_SN;
    return TRUE;
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Start(pMPIO_DATA pMPIODATA)
{
	AME_Msg("Host_Start : %d\n",pMPIODATA->MPIO_Serial_Number);
    return AME_Start((pAME_Data)pMPIODATA->pAMEData);
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Stop(pMPIO_DATA pMPIODATA)
{
	AME_U32		i;
	pMPIO_DATA 	path_MPIODATA,pMPIODATA_temp;

	if (MPIO_HBA_Count == 0) {
		AME_Msg_Err("(%d)Host_Stop fail: Host_Count = 0\n",pMPIODATA->MPIO_Serial_Number);
		return FALSE;		
	} else {
		MPIO_HBA_Count--;
		AME_Msg("(%d)Host_Stop : MPIO_HBA_Count\n",pMPIODATA->MPIO_Serial_Number,MPIO_HBA_Count);
    }

	// remove the MPIOGlobal.pMPIOData
	for (i=0;i<MPIO_MAX_support_HBA;i++) {
		if (MPIOGlobal.pMPIOData[i] == pMPIODATA) {
			AME_Msg("(%d)Host_Stop: Clear MPIOGlobal.pMPIOData[%d] = NULL\n",pMPIODATA->MPIO_Serial_Number,i);
			MPIOGlobal.pMPIOData[i] = NULL;
			break;
		}
	}

	if (FALSE == MPIO_Support_Check(pMPIODATA)) {
		return AME_Stop((pAME_Data)pMPIODATA->pAMEData);
    }

	// remove the the physical RAID of this Host.
    for (i=0;i<MAX_RAID_System_ID;i++) {
    	if (pMPIODATA->RAIDDATA[i].Path_State == MPIO_Path_Built ) {
    		MPIO_Path_Remove(pMPIODATA->RAIDDATA[i].pMPIOData_host,pMPIODATA,pMPIODATA->RAIDDATA[i].host_RaidID ,i,FALSE);
    	}
    }
    
	MPIO_Data_Init(pMPIODATA,FALSE);
	
	return AME_Stop((pAME_Data)pMPIODATA->pAMEData);
}

AME_U32 MPIO_Path_Remove_extern(pMPIO_DATA pMPIODATA)
{
	AME_U32		i, PATHCount;
	pMPIO_DATA 	pMPIODATA_Host, pMPIODATA_Path;

	if (FALSE == MPIO_Support_Check(pMPIODATA)) {
		return TRUE;
    }
	
    //AME_Msg("(%d)MPIO_Path_Remove_extern : MPIO_HBA_Count %d\n",pMPIODATA->MPIO_Serial_Number,MPIO_HBA_Count);

	// remove the the physical RAID of this Host.
    for (i=0;i<MAX_RAID_System_ID;i++) {
    	if (pMPIODATA->RAIDDATA[i].Path_State == MPIO_Path_Built) {
    		MPIO_Path_Remove(pMPIODATA->RAIDDATA[i].pMPIOData_host,pMPIODATA,pMPIODATA->RAIDDATA[i].host_RaidID ,i,FALSE);
    	}
    }
    
	MPIO_Data_Init(pMPIODATA,FALSE);
	
	return TRUE;    //AME_Stop((pAME_Data)pMPIODATA->pAMEData);
}


AME_U32 MPIO_Support_Check(pMPIO_DATA pMPIODATA)
{
    #ifndef Enable_MPIO
        //AME_Msg("MPIO_Support_Check: not define Enable_MPIO return FALSE!\n",pMPIODATA->MPIO_Serial_Number);
        return FALSE;
    #endif

    if ((pMPIODATA->Device_ID == AME_8608_DID1_TBS) ||
        (pMPIODATA->Device_ID == AME_8608_DID2_TBS) ||
        (pMPIODATA->Device_ID == AME_87B1_DID_TBS) ||
        (pMPIODATA->Device_ID == AME_8733_DID_TBS)) {
        return TRUE;
    }
    
    if (TRUE == AME_Check_is_Raid_R50((pAME_Data)pMPIODATA->pAMEData)) {
        //AME_Msg("MPIO_Support_Check: Raid R50 return TRUE!\n",pMPIODATA->MPIO_Serial_Number);
        return TRUE;
    }
    
	return FALSE;
}


AME_U32 MPIO_Lun_Alive_Check (pMPIO_DATA pHost_MPIODATA,AME_U32 Raid_ID,AME_U32 Lun_ID)
{
	pMPIO_DATA	pPath_MPIODATA;

	if (FALSE == MPIO_Support_Check(pHost_MPIODATA)) {
		return AME_Lun_Alive_Check((pAME_Data)pHost_MPIODATA->pAMEData,Raid_ID,Lun_ID);
    }

	if (pHost_MPIODATA->MPIO_RAIDDATA[Raid_ID].PATHCount == 0) {
		return FALSE;
    }
		
	pPath_MPIODATA = pHost_MPIODATA->MPIO_RAIDDATA[Raid_ID].Path_RAIDData[0].pMPIOData;

	return AME_Lun_Alive_Check((pAME_Data)pPath_MPIODATA->pAMEData,Raid_ID,Lun_ID);
}


AME_U32 MPIO_NT_Raid_Alive_Check (pMPIO_DATA pHost_MPIODATA,AME_U32 Raid_ID)
{
	pMPIO_DATA	pPath_MPIODATA;

	if (FALSE == MPIO_Support_Check(pHost_MPIODATA)) {
		return AME_NT_Raid_Alive_Check((pAME_Data)pHost_MPIODATA->pAMEData,Raid_ID);
    }

	if (pHost_MPIODATA->MPIO_RAIDDATA[Raid_ID].PATHCount == 0) {
		return FALSE;
    }
	
	pPath_MPIODATA = pHost_MPIODATA->MPIO_RAIDDATA[Raid_ID].Path_RAIDData[0].pMPIOData;
	return AME_NT_Raid_Alive_Check((pAME_Data)pPath_MPIODATA->pAMEData,Raid_ID);

}

AME_U32 MPIO_Check_Multiple_Path(pMPIO_DATA pMPIODATA,pMPIO_Get_PAGE_0_Data pMPIO_Get_PAGE0_Data ,AME_U32 Raid_ID)
{

	// 1. check RAID path can been added into MPIO path, 
	// 2. else, create the RAID ID MPIO path

	AME_U32		i,j;
	pMPIO_DATA 	pMPIODATA_temp;

	if ((TRUE == AME_Check_is_Raid_R50((pAME_Data)pMPIODATA->pAMEData)) && (Raid_ID == 19)) {
        //MPIO_Msg("******** (%d)MPIO_Check_Multiple_Path:  Raid:%d, R50 stop support!\n",pMPIODATA->MPIO_Serial_Number,Raid_ID);
        return TRUE;
    }
	
	// 1. check RAID path can been added into MPIO path,
	for (i=0;i<MPIO_MAX_support_HBA;i++) {
		
		if (MPIOGlobal.pMPIOData[i] != NULL)
		{
			pMPIODATA_temp = (pMPIO_DATA)MPIOGlobal.pMPIOData[i];
			//MPIO_Msg("******** (%d)MPIO_Check_Multiple_Path 1:  Raid:%d, (%d)GpMPIOData = %p, pMPIODATA = %p\n",pMPIODATA->MPIO_Serial_Number,Raid_ID,i,pMPIODATA_temp,pMPIODATA);

		    for (j=0;j<MAX_RAID_System_ID;j++) {
            
		    	// Serial_Number check
		    	// Model_Name check
		    	// Production_ID check
		    	if ((TRUE == pMPIODATA_temp->MPIO_RAIDDATA[j].GetPAGE0_Data.Ready) &&
		    	    (TRUE == AME_Memory_Compare(pMPIODATA_temp->MPIO_RAIDDATA[j].GetPAGE0_Data.Serial_Number,pMPIO_Get_PAGE0_Data->Serial_Number,0x10)) && 
		    	    (TRUE == AME_Memory_Compare(pMPIODATA_temp->MPIO_RAIDDATA[j].GetPAGE0_Data.Model_Name,pMPIO_Get_PAGE0_Data->Model_Name,0x10)) &&
		    	    (TRUE == AME_Memory_Compare(pMPIODATA_temp->MPIO_RAIDDATA[j].GetPAGE0_Data.Production_ID,pMPIO_Get_PAGE0_Data->Production_ID,0x10)))
		        {
                    AME_U32 lun_ID,lun_check1,lun_check2,ret = TRUE;
                    
                    //MPIO_Msg("******** (%d)MPIO_Check_Multiple_Path 2:  Raid:%d, (%d)GpMPIOData = %p, pMPIODATA = %p\n",pMPIODATA->MPIO_Serial_Number,Raid_ID,i,pMPIODATA_temp,pMPIODATA);
                    for (lun_ID=0;lun_ID<MAX_RAID_LUN_ID;lun_ID++) {
                        lun_check1 = AME_Lun_Alive_Check((pAME_Data)pMPIODATA_temp->pAMEData,Raid_ID,lun_ID);
                        lun_check2 = AME_Lun_Alive_Check((pAME_Data)pMPIODATA->pAMEData,Raid_ID,lun_ID);
                        if (lun_check1 != lun_check2) {
                            ret = FALSE;
                        }
                    }
                    
                    //Masked NT device for Mac M1, not support Switch, Max24, and stop T-share T-pairing
                    #ifdef Disable_M1_Support_NT
                        ret = FALSE;
                    #endif
                    
                    if (ret == TRUE) {
                        MPIO_Path_Add(pMPIODATA_temp,pMPIODATA,j,Raid_ID);
                        return TRUE;
                    }
                    
		    	}
		    	
		    }
		}
	}

	
	// 2. else, create the RAID ID MPIO path
	MPIO_GetPAGE0_Data_Add(pMPIODATA,pMPIO_Get_PAGE0_Data,Raid_ID);
	MPIO_Path_Add(pMPIODATA,pMPIODATA,Raid_ID,Raid_ID);

	return TRUE;
	
}

AME_U32 MPIO_Check_MPIO_Master_Path(pMPIO_DATA pMPIODATA)
{
    // Default to check Raid ID = 0, MPIO support T-share and Max Raid(R50), Raid ID = 0.
    if (pMPIODATA->RAIDDATA[0].Path_State == MPIO_Path_Built) {
        if (pMPIODATA->RAIDDATA[0].pMPIOData_host == pMPIODATA) {
            return TRUE;
        }
    }
    
    return FALSE;
}

// After Get RAID ready, I just can confirm the path is exist.
AME_U32 MPIO_AME_RAID_Ready(pAME_Data pAMEData,AME_U32 Raid_ID, AME_U64 Get_Page0_data)
{
	pMPIO_DATA pMPIODATA = (pMPIO_DATA)pAMEData->pMPIOData;

	if (FALSE == MPIO_Support_Check(pMPIODATA)) {
		return TRUE;
    }
    
    if (pAMEData->AME_RAIDData[Raid_ID].Raid_Error_Handle_State == TRUE) {
        return TRUE;
    }
    
    MPIO_Msg("Host :%d, Raid:%d Ready\n",pMPIODATA->MPIO_Serial_Number,Raid_ID);
	AME_Memory_copy((PVOID)(pMPIODATA->RAIDDATA[Raid_ID].GetPAGE0_Data.Production_ID), (PVOID)(Get_Page0_data+0x00), 0x10);
	AME_Memory_copy((PVOID)(pMPIODATA->RAIDDATA[Raid_ID].GetPAGE0_Data.Model_Name), (PVOID)(Get_Page0_data+0x10), 0x10);
	AME_Memory_copy((PVOID)(pMPIODATA->RAIDDATA[Raid_ID].GetPAGE0_Data.Serial_Number), (PVOID)(Get_Page0_data+0x20), 0x10);
	
	MPIO_Check_Multiple_Path(pMPIODATA,&(pMPIODATA->RAIDDATA[Raid_ID].GetPAGE0_Data),Raid_ID);
	
	return TRUE;
}


AME_U32 MPIO_Build_InBand_Cmd(pMPIO_DATA pMPIODATA, pAME_Module_InBand_Command pAME_ModuleInBand_Command)
{
    if(AME_Check_is_TBS_Device((pAME_Data)pMPIODATA)) {
    	return (AME_Build_InBand_Cmd_NT((pAME_Data)pMPIODATA->pAMEData,pAME_ModuleInBand_Command) ); 
    } else {
        if ((AME_Check_is_A12_T3S((pAME_Data)pMPIODATA->pAMEData) == TRUE) ||
            (AME_Check_is_Raid_R50((pAME_Data)pMPIODATA->pAMEData) == TRUE))
        {
            return (AME_Build_InBand_Cmd_NT((pAME_Data)pMPIODATA->pAMEData,pAME_ModuleInBand_Command) ); 
        } else {
            return (AME_Build_InBand_Cmd_DAS((pAME_Data)pMPIODATA->pAMEData,pAME_ModuleInBand_Command) ); 
        }
    }
}


AME_U32 
pin_pon_queue_algorithm(pMPIO_DATA pMPIODATA, AME_U32 Raid_ID, pPath_RAID_DATA output_pPath_RAIDData)
{
	AME_U32		i=0;
		
	// pin-pon queue
	i = pMPIODATA->MPIO_RAIDDATA[Raid_ID].TotalIssue_CMDCount % pMPIODATA->MPIO_RAIDDATA[Raid_ID].PATHCount;
	AME_Memory_copy((PVOID)output_pPath_RAIDData, (PVOID)(&pMPIODATA->MPIO_RAIDDATA[Raid_ID].Path_RAIDData[i]), sizeof(Path_RAID_DATA));

	return TRUE;
}


AME_U32 
#if defined (AME_MAC)
	DRV_MAIN_CLASS_NAME::
#endif 
MPIO_Build_SCSI_Cmd(pMPIO_DATA pMPIODATA, pAME_Module_SCSI_Command pAME_ModuleSCSI_Command)
{
	AME_U32			Raid_ID = pAME_ModuleSCSI_Command->Raid_ID;
	pMPIO_DATA		pPath_MPIODATA = pMPIODATA;
	Path_RAID_DATA	Path_RAIDData;
	
	if (FALSE == MPIO_Support_Check(pMPIODATA)) {
		if (FALSE == AME_Build_SCSI_Cmd((pAME_Data)pMPIODATA->pAMEData,(pAME_Data)pMPIODATA->pAMEData,pAME_ModuleSCSI_Command)) {
			AME_Msg_Err("(%d)AME_Build_SCSI_Cmd Fail\n",pMPIODATA->MPIO_Serial_Number);
			return FALSE;
		}
		return TRUE;
	}

	if (pMPIODATA->MPIO_RAIDDATA[Raid_ID].PATHCount == 0) {
		MPIO_Msg_Err("(%d)T-Pairing_Build_SCSI_Cmd : PATHCount = 0, ???\n",pMPIODATA->MPIO_Serial_Number);
		return FALSE;
	}
		
	if (TRUE == AME_Check_is_Raid_R50((pAME_Data)pMPIODATA->pAMEData)) {
        //AME_Msg("MPIO_Support_Check: Raid R50 return TRUE!\n",pMPIODATA->MPIO_Serial_Number);
        if (FALSE == AME_Build_SCSI_Cmd((pAME_Data)pMPIODATA->pAMEData,(pAME_Data)pMPIODATA->pAMEData,pAME_ModuleSCSI_Command)) {
			AME_Msg_Err("(%d)AME_Build_SCSI_Cmd Fail\n",pMPIODATA->MPIO_Serial_Number);
			return FALSE;
		}
    }
    else { //ThunderBolt T-Pairing (T2-share or T3-share)
	
	    //round-robin algorithms
	    pin_pon_queue_algorithm(pMPIODATA,Raid_ID,&Path_RAIDData);
	    pPath_MPIODATA = Path_RAIDData.pMPIOData;
	    
	    switch(pAME_ModuleSCSI_Command->CDB[0])
	    {
            case SCSIOP_READ:
            case SCSIOP_READ6:
            case SCSIOP_READ12:
            case SCSIOP_READ16:
                //round-robin algorithms
                //pPath_MPIODATA = pMPIODATA;
                //MPIO_Msg("(%d)MPIO_Build_SCSI_Cmd : SCSIOP_READ(type 0x%x)(%d)\n",pMPIODATA->MPIO_Serial_Number,pAME_ModuleSCSI_Command->CDB[0],pPath_MPIODATA->MPIO_Serial_Number);
                //MPIO_Msg("(%d)MPIO_Build_SCSI_Cmd : SCSIOP_READ(length 0x%x SGCount %d)(%d)\n",pMPIODATA->MPIO_Serial_Number,pAME_ModuleSCSI_Command->DataLength,pAME_ModuleSCSI_Command->SGCount,pPath_MPIODATA->MPIO_Serial_Number);
                break;
            
            case SCSIOP_WRITE:
            case SCSIOP_WRITE6:
            case SCSIOP_WRITE12:
            case SCSIOP_WRITE16:
                //pPath_MPIODATA = pMPIODATA;
                //MPIO_Msg("(%d)MPIO_Build_SCSI_Cmd : Write_CMD(%d)\n",pMPIODATA->MPIO_Serial_Number,pPath_MPIODATA->MPIO_Serial_Number);
                //MPIO_Msg("(%d)MPIO_Build_SCSI_Cmd : Write_CMD(length 0x%x SGCount %d)(%d)\n",pMPIODATA->MPIO_Serial_Number,pAME_ModuleSCSI_Command->DataLength,pAME_ModuleSCSI_Command->SGCount,pPath_MPIODATA->MPIO_Serial_Number);
                break;
            default:
                pPath_MPIODATA = pMPIODATA;
                //MPIO_Msg("(%d)MPIO_Build_SCSI_Cmd : Non-R/W_CMD(%d)\n",pMPIODATA->MPIO_Serial_Number,pPath_MPIODATA->MPIO_Serial_Number);
                //MPIO_Msg("(%d)MPIO_Build_SCSI_Cmd :  Non-R/W_CMD(length 0x%x SGCount %d)(%d)\n",pMPIODATA->MPIO_Serial_Number,pAME_ModuleSCSI_Command->DataLength,pAME_ModuleSCSI_Command->SGCount,pPath_MPIODATA->MPIO_Serial_Number);
                break;
        }
	    
	    //MPIO_Msg("(%d)MPIO_Build_SCSI_Cmd : Path (%d)\n",pMPIODATA->MPIO_Serial_Number,pPath_MPIODATA->MPIO_Serial_Number);
        
	    if (FALSE == AME_Build_SCSI_Cmd((pAME_Data)pMPIODATA->pAMEData,(pAME_Data)pPath_MPIODATA->pAMEData,pAME_ModuleSCSI_Command)) {
	    	MPIO_Msg_Err("(%d)T-Pairing_Build_SCSI_Cmd Fail\n",pMPIODATA->MPIO_Serial_Number);
	    	MPIO_Msg_Err("error count (%d)\n",pMPIODATA->MPIO_RAIDDATA[Raid_ID].TotalIssue_CMDCount);
	    	return FALSE;
	    }
	    
	    MPIO_spinlock(pMPIODATA);
	    pMPIODATA->MPIO_RAIDDATA[Raid_ID].TotalIssue_CMDCount++;
	    MPIO_spinunlock(pMPIODATA);
	}
	
	return TRUE;
}


//Call from Mac and Linux OS Cmd timeout
AME_U32 MPIO_Cmd_Timeout(pMPIO_DATA pMPIODATA,PVOID pRequestExtension)
{
	return (AME_Cmd_Timeout((pAME_Data)pMPIODATA->pAMEData,pRequestExtension));
}

//Call from Win OS bus reset
AME_U32 MPIO_Cmd_All_Timeout(pMPIO_DATA pMPIODATA)
{
	return (AME_Cmd_All_Timeout((pAME_Data)pMPIODATA->pAMEData));
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Host_Fast_handler_SCSI_REQUEST (pAME_REQUEST_CallBack pAME_REQUESTCallBack)
{
    return AME_Host_Fast_handler_SCSI_REQUEST(pAME_REQUESTCallBack);
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Host_Normal_handler_SCSI_REQUEST (pAME_REQUEST_CallBack pAME_REQUESTCallBack)
{
	return AME_Host_Normal_handler_SCSI_REQUEST(pAME_REQUESTCallBack);
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Host_Error_handler_SCSI_REQUEST (pAME_REQUEST_CallBack pAME_REQUESTCallBack)
{
	return AME_Host_Error_handler_SCSI_REQUEST(pAME_REQUESTCallBack);
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Host_Normal_handler_IN_Band (pAME_REQUEST_CallBack pAMEREQUESTCallBack)
{
	return (AME_Host_Normal_handler_IN_Band(pAMEREQUESTCallBack));
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Timer (pMPIO_DATA pMPIODATA)
{
	return TRUE;
}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Host_Scan_All_Lun (pAME_Data pAMEData,AME_U32 RAID_ID)
{
	pMPIO_DATA 	pPath_MPIODATA = (pMPIO_DATA)pAMEData->pMPIOData;
	pMPIO_DATA	pMPIODATA_temp = NULL;
	AME_U32		i,j,k;
	AME_U32		PATHCount;
	
	if (FALSE == MPIO_Support_Check(pPath_MPIODATA)) {
		return (AME_Host_Scan_All_Lun(pAMEData,RAID_ID));
    }
	
	for (i=0; i<MPIO_MAX_support_HBA; i++)
	{
		if (MPIOGlobal.pMPIOData[i] == NULL) {
			continue;
        }
		
		pMPIODATA_temp = (pMPIO_DATA)MPIOGlobal.pMPIOData[i];

		for (j=0; j<MAX_RAID_System_ID; j++)
        {
			PATHCount = pMPIODATA_temp->MPIO_RAIDDATA[j].PATHCount;
			
			for (k=0; k<PATHCount; k++)
            {
				if ((pMPIODATA_temp->MPIO_RAIDDATA[j].Path_RAIDData[k].pMPIOData == pPath_MPIODATA) &&
					(pMPIODATA_temp->MPIO_RAIDDATA[j].Path_RAIDData[k].AME_RAID_ID == RAID_ID)) {
					    
                    // When single NT cable plug out case, pHostDATA->pPathData[0] remove already.
                    // Driver must be return FALSE,and don't call AME_Host_Lun_Change Function.
                    // In this case, PATHCount = 0, so we add a new condition to avoid error.
                    //if ((pPath_MPIODATA != pHostDATA->pPathData[0]) &&
                        //(pHostDATA->PATHCount != 0)) {
                    	//return FALSE;
                    //}
                    if (k != 0) {	// not first path
                    	return FALSE;
                    } else {
                    	RAID_ID = j;
                    	MPIO_Msg("AME_Host_Scan_All_Lun,Host:%d, Raid:%d \n",pMPIODATA_temp->MPIO_Serial_Number,RAID_ID);
                    	return (AME_Host_Scan_All_Lun((pAME_Data)pMPIODATA_temp->pAMEData,RAID_ID));
                    }
					
				}
			}
		}
	}

	// need to check single NT cable plug out case, ???
	if (pMPIODATA_temp != NULL) {
	    MPIO_Msg("AME_Host_Scan_All_Lun,Host:%d, Raid:%d, pathcount=0 \n",pMPIODATA_temp->MPIO_Serial_Number,RAID_ID);
	}
	return (AME_Host_Scan_All_Lun(pAMEData,RAID_ID));

}


AME_U32 
#if defined (AME_MAC)
		DRV_MAIN_CLASS_NAME::
#endif
MPIO_Host_Lun_Change (pAME_Data pAMEData,AME_U32 RAID_ID,AME_U32 lun_ID,AME_U32 State)
{
	pMPIO_DATA 	pPath_MPIODATA = (pMPIO_DATA)pAMEData->pMPIOData;
	pMPIO_DATA	pMPIODATA_temp;
	AME_U32		i,j,k;
	AME_U32		PATHCount;

	MPIO_Msg("****** AME_Host_Lun_Change: Host:%d, Raid:%d, Lun:%d, state:%d \n",pPath_MPIODATA->MPIO_Serial_Number,RAID_ID,lun_ID,State);
	
	if (FALSE == MPIO_Support_Check(pPath_MPIODATA)) {
		return (AME_Host_Lun_Change(pAMEData,RAID_ID,lun_ID,State));
    }

	// 1. check RAID path can been added into MPIO path, 
	for (i=0;i<MPIO_MAX_support_HBA;i++) {
		
		if (MPIOGlobal.pMPIOData[i] == NULL) {
			continue;
	    }
		
		pMPIODATA_temp = (pMPIO_DATA)MPIOGlobal.pMPIOData[i];

		for (j=0;j<MAX_RAID_System_ID;j++) {
			
			PATHCount = pMPIODATA_temp->MPIO_RAIDDATA[j].PATHCount;
			
			for (k=0;k<PATHCount;k++) {
			    if ((pMPIODATA_temp->MPIO_RAIDDATA[j].Path_RAIDData[k].pMPIOData == pPath_MPIODATA) &&
			        (pMPIODATA_temp->MPIO_RAIDDATA[j].Path_RAIDData[k].AME_RAID_ID == RAID_ID)) {
		            
		            if (PATHCount == 1) {
		                MPIO_Msg("AME_Host_Lun_Change,PATHCount:%d, Host:%d, Raid:%d, Lun:%d, state:%d \n",PATHCount,pMPIODATA_temp->MPIO_Serial_Number,RAID_ID,lun_ID,State);
			            return (AME_Host_Lun_Change((pAME_Data)pMPIODATA_temp->pAMEData,RAID_ID,lun_ID,State));
		            }
		            
		            if ((PATHCount > 1) &&
		                (k == 0)) {
                        MPIO_Msg("AME_Host_Lun_Change,PATHCount:%d, Host:%d, Raid:%d, Lun:%d, state:%d \n",PATHCount,pMPIODATA_temp->MPIO_Serial_Number,RAID_ID,lun_ID,State);
			            return (AME_Host_Lun_Change((pAME_Data)pMPIODATA_temp->pAMEData,RAID_ID,lun_ID,State));
		            }
		            
		            MPIO_Msg("AME_Host_Lun_Change Stop, because have other path,PATHCount:%d, Host:%d, Raid:%d, Lun:%d, state:%d \n",PATHCount,pMPIODATA_temp->MPIO_Serial_Number,RAID_ID,lun_ID,State);
		            
		            return FALSE;
		        }
		    }
		}
	}

	return TRUE;

}


AME_U32 MPIO_Slave_LED_ON(pAME_Data pAMEData)
{
    AME_U32 i, PATHCount;
    pMPIO_DATA 	pMPIODATA_Master, pMPIODATA_Slave;
    pMPIODATA_Master = (pMPIO_DATA)pAMEData->pMPIOData;
    
    if (FALSE == MPIO_Support_Check(pMPIODATA_Master)) {
        AME_LED_ON(pAMEData);
        return FALSE;
    }
    
    // Default to check Raid ID = 0, MPIO support T-share and Max Raid(R50), Raid ID = 0.
    PATHCount = pMPIODATA_Master->MPIO_RAIDDATA[0].PATHCount;
    
    for (i=0; i<PATHCount; i++) {
		
        // Default to check Raid ID = 0, MPIO support T-share and Max Raid(R50), Raid ID = 0.
        if (pMPIODATA_Master->MPIO_RAIDDATA[0].Path_RAIDData[i].pMPIOData != NULL) {
			pMPIODATA_Slave = pMPIODATA_Master->MPIO_RAIDDATA[0].Path_RAIDData[i].pMPIOData;
            AME_LED_ON((pAME_Data)pMPIODATA_Slave->pAMEData);
	    }
	}
    
    
    return TRUE;
}

AME_U32 MPIO_Slave_LED_OFF(pAME_Data pAMEData)
{
    AME_U32 i, PATHCount;
    pMPIO_DATA 	pMPIODATA_Master, pMPIODATA_Slave;
    pMPIODATA_Master = (pMPIO_DATA)pAMEData->pMPIOData;
    
    if (FALSE == MPIO_Support_Check(pMPIODATA_Master)) {
        AME_LED_OFF(pAMEData);
        return FALSE;
    }
    
    // Default to check Raid ID = 0, MPIO support T-share and Max Raid(R50), Raid ID = 0.
    PATHCount = pMPIODATA_Master->MPIO_RAIDDATA[0].PATHCount;
    
    for (i=0; i<PATHCount; i++) {
		
        // Default to check Raid ID = 0, MPIO support T-share and Max Raid(R50), Raid ID = 0.
        if (pMPIODATA_Master->MPIO_RAIDDATA[0].Path_RAIDData[i].pMPIOData != NULL) {
			pMPIODATA_Slave = pMPIODATA_Master->MPIO_RAIDDATA[0].Path_RAIDData[i].pMPIOData;
            AME_LED_OFF((pAME_Data)pMPIODATA_Slave->pAMEData);
	    }
	}
    
    return TRUE;
}


