
#ifndef OSDefine_H

    #define OSDefine_H
    
    #define AME_Module_version "2.1.10.8"
    #define AME_Module_Modify_Time "2022/02/14"
    
    /* Select OS define */
    //#define AME_MAC
    //#define AME_Windows
    #define AME_Linux
    
    #ifdef AME_MAC
        
        //#define MacOS_109
        #define MacOS_11
        
        #define Driver_Ver "2.5.7 Beta7"
        #define Driver_OS_Ver " Mac driver, version: " Driver_Ver
        
        #ifdef MacOS_109
            /* Only supports OS versions above Mac OS 10.9, and support Thunderbolt device */
            #define TB_Func_support
        #endif
        
        #ifdef MacOS_11
            /* Only supports OS versions above Mac OS 10.9, and support Thunderbolt device */
            #define TB_Func_support
            #define Allocate_memory_onece   //Support Mac 11 Big Sur and above memory allocate mode
            
            #if defined(__arm64__)  /* Support M1 and above chip ARM 64bit cpu, using new IODMACommand APIs */
                #define Support_Mac_M1_ARM64  //Add DMA Mapping function
                #define Enable_New_LUT  // For NT series add new LUT setting
                #define Disable_M1_Support_MAX   //Masked NT device for Mac M1, not support Max24
                #define STOP_Mac_Big_Sur_M1_Scan_PCI_device //Fixed Big Sur scan low bus number result to panic issue
            #endif
        #endif
    #endif
    
    #ifdef AME_Windows
        #define Driver_Ver "2.5.0.7 Beta9"
        #define Enable_New_LUT  // For NT series add new LUT setting
        #ifdef USE_STORPORT
            #define Driver_OS_Ver " Win storport driver, version: " Driver_Ver
        #else
            #define Driver_OS_Ver " Win miniport driver, version: " Driver_Ver
        #endif
        //#define Win_spinlock //Win OS, OS auto lock
        //#define Support_LogMemory //LogMemory only support windows
    #endif
    
    #ifdef AME_Linux
        #define Driver_Ver "3.7.2"
        #define Driver_OS_Ver " Linux driver, version: " Driver_Ver
        #define Enable_New_LUT  // For NT series add new LUT setting
        //#define Support_VersaPLX_DAS            //Support VersaPLX Raid
        //#define Support_VersaPLX_Cavium       //Support VersaPLX Raid
        //#define Support_VersaPLX_FT2000_Plus  //Support VersaPLX Raid
    #endif
    
    /* AME Message enable */
    #define Enable_AME_message
    #define Enable_MPIO_message
    
    /* MPIO and Raid R50 support enable */
    #define Enable_MPIO
    
    /* HBA eeprom update support enable */
    #define Enable_AME_eeprom_update
    
    /* Support Dell computer, Only Dell computer used with win or linux OS */
    /* Driver will update Dell eeprom to HBA eeprom */
    #ifdef Enable_AME_eeprom_update
        //#define Support_Dell_eeprom_update
    #endif
    
    /* This update for New Mac OS, ӳWwb䴩 device mapping Bar, eN]w睊 
       Support NT device have cfg bar mapping to Bar0 */
    //#define Update_New_NT_Bar_eeprom

#endif //OSDefine_H

